package org.jeecg.modules.fbsAbnormalWorkingHours.service.impl;

import com.baomidou.dynamic.datasource.annotation.DS;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import org.jeecg.modules.fbsAbnormalWorkingHours.entity.FbsAbnormalWorkingHours;
import org.jeecg.modules.fbsAbnormalWorkingHours.entity.FbsAbnormalWorkingHoursDescribe;
import org.jeecg.modules.fbsAbnormalWorkingHours.entity.FbsAbnormalWorkingHoursType;
import org.jeecg.modules.fbsAbnormalWorkingHours.mapper.FbsAbnormalWorkingHoursMapper;
import org.jeecg.modules.fbsAbnormalWorkingHours.service.IFbsAbnormalWorkingHoursDescribeService;
import org.jeecg.modules.fbsAbnormalWorkingHours.service.IFbsAbnormalWorkingHoursService;
import org.jeecg.modules.fbsAbnormalWorkingHours.service.IFbsAbnormalWorkingHoursTypeService;
import org.jeecg.modules.fbsPerson.entity.FbsPerson;
import org.jeecg.modules.fbsPerson.mapper.FbsPersonMapper;
import org.jeecg.modules.fbsPerson.service.IFbsPersonService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;
import java.util.List;

/**
 * @Description: 生产异常信息统计单
 * @author： jeecg-boot
 * @date：   2020-10-13
 * @version： V1.0
 */
@Service
@Transactional
public class FbsAbnormalWorkingHoursServiceImpl extends ServiceImpl<FbsAbnormalWorkingHoursMapper, FbsAbnormalWorkingHours> implements IFbsAbnormalWorkingHoursService {

    @Resource
    private FbsAbnormalWorkingHoursMapper fbsAbnormalWorkingHoursMapper;

    @Resource
    private IFbsAbnormalWorkingHoursDescribeService iFbsAbnormalWorkingHoursDescribeService;

    @Resource
    private IFbsAbnormalWorkingHoursTypeService iFbsAbnormalWorkingHoursTypeService;

    @Override
    public boolean addAndChild(FbsAbnormalWorkingHours fbsAbnormalWorkingHours) {
        boolean resulet=true;
        //新增主表
        fbsAbnormalWorkingHoursMapper.insert(fbsAbnormalWorkingHours);

        //新增子表
        addChild(fbsAbnormalWorkingHours);

        return resulet;
    }

    /**
    * @Author chenchuang
    * @Description //TODO 新增子表
    * @Date 2020/10/14 15:21
    * @Param [fbsAbnormalWorkingHours]
    * @return void
    */
    public void addChild(FbsAbnormalWorkingHours fbsAbnormalWorkingHours){
        //新增异常工时描述
        if(fbsAbnormalWorkingHours.getFbsAbnormalWorkingHoursDescribeList()!=null){
            Integer sort=1;
            for(FbsAbnormalWorkingHoursDescribe fbsAbnormalWorkingHoursDescribe:fbsAbnormalWorkingHours.getFbsAbnormalWorkingHoursDescribeList()){
                fbsAbnormalWorkingHoursDescribe.setId(null);
                fbsAbnormalWorkingHoursDescribe.setAbnormalWorkingHoursId(fbsAbnormalWorkingHours.getId());
                fbsAbnormalWorkingHoursDescribe.setSort(sort);
                sort++;
            }
            //批量保存
            iFbsAbnormalWorkingHoursDescribeService.saveBatch(fbsAbnormalWorkingHours.getFbsAbnormalWorkingHoursDescribeList());
        }

        //新增异常类别
        if(fbsAbnormalWorkingHours.getFbsAbnormalWorkingHoursTypeList()!=null){
            Integer sort=1;
            for(FbsAbnormalWorkingHoursType fbsAbnormalWorkingHoursType:fbsAbnormalWorkingHours.getFbsAbnormalWorkingHoursTypeList()){
                fbsAbnormalWorkingHoursType.setId(null);
                fbsAbnormalWorkingHoursType.setAbnormalWorkingHoursId(fbsAbnormalWorkingHours.getId());
                fbsAbnormalWorkingHoursType.setSort(sort);
                sort++;
            }
            //批量保存
            iFbsAbnormalWorkingHoursTypeService.saveBatch(fbsAbnormalWorkingHours.getFbsAbnormalWorkingHoursTypeList());
        }
    }

    @Override
    public boolean updateAndChild(FbsAbnormalWorkingHours fbsAbnormalWorkingHours) {
        boolean resulet=true;
//        //新增主表
//        fbsAbnormalWorkingHoursMapper.updateById(fbsAbnormalWorkingHours);
//        //物理删除子表旧数据
//        deleteChild(fbsAbnormalWorkingHours);
//        //新增子表
//        addChild(fbsAbnormalWorkingHours);

        pp();
        return resulet;
    }

    @Autowired
    IFbsPersonService iFbsPersonService;


    public void pp(){
        List<FbsPerson> fbsPersonList=iFbsPersonService.list();
    }

    /**
    * @Author chenchuang
    * @Description //TODO 物理删除子表数据
    * @Date 2020/10/14 15:33
    * @Param [fbsAbnormalWorkingHours]
    * @return void
    */
    public void deleteChild(FbsAbnormalWorkingHours fbsAbnormalWorkingHours){
        //物理删除异常工时描述
        LambdaQueryWrapper<FbsAbnormalWorkingHoursDescribe> describeLambdaQueryWrapper=new LambdaQueryWrapper<>();
        describeLambdaQueryWrapper.eq(FbsAbnormalWorkingHoursDescribe::getAbnormalWorkingHoursId,fbsAbnormalWorkingHours.getId());
        describeLambdaQueryWrapper.eq(FbsAbnormalWorkingHoursDescribe::getDelFlag,"0");
        FbsAbnormalWorkingHoursDescribe fbsAbnormalWorkingHoursDescribe=new FbsAbnormalWorkingHoursDescribe();
        fbsAbnormalWorkingHoursDescribe.setDelFlag("1");
        iFbsAbnormalWorkingHoursDescribeService.update(fbsAbnormalWorkingHoursDescribe,describeLambdaQueryWrapper);
        //物理删除异常类别
        LambdaQueryWrapper<FbsAbnormalWorkingHoursType> typeLambdaQueryWrapper=new LambdaQueryWrapper<>();
        typeLambdaQueryWrapper.eq(FbsAbnormalWorkingHoursType::getAbnormalWorkingHoursId,fbsAbnormalWorkingHours.getId());
        typeLambdaQueryWrapper.eq(FbsAbnormalWorkingHoursType::getDelFlag,"0");
        FbsAbnormalWorkingHoursType fbsAbnormalWorkingHoursType=new FbsAbnormalWorkingHoursType();
        fbsAbnormalWorkingHoursType.setDelFlag("1");
        iFbsAbnormalWorkingHoursTypeService.update(fbsAbnormalWorkingHoursType,typeLambdaQueryWrapper);
    }
}
